{=======================================================================================================================

   " ".

========================================================================================================================
  Copyright 19972015 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: ComputerWare.dpr,v 1.83 2015/03/09 12:23:04 tsk Exp $
=======================================================================================================================}
program ComputerWare;

uses
  Forms,
  Windows,
  dgBaseEdit           in 'Source\Base\dgBaseEdit.pas' {BaseEditDG},
  dgBaseFind           in 'Source\Base\dgBaseFind.pas' {BASEFindDG},
  dgBaseList           in 'Source\Base\dgBaseList.pas' {BASEListDG},
  fmChangeList         in 'Source\Change\fmChangeList.pas' {ChangeListFM},
  dmChainData          in 'Source\Data\dmChainData.pas' {dmChain: TDataModule},
  dmCommingData        in 'Source\Data\dmCommingData.pas' {dmComming: TDataModule},
  dmLookUpData         in 'Source\Data\dmLookUpData.pas' {dmLookUp: TDataModule},
  dgDocumentKindEdit   in 'Source\Document\Kind\dgDocumentKindEdit.pas' {DocumentKindEditDG},
  dgDocumentKindList   in 'Source\Document\Kind\dgDocumentKindList.pas' {DocumentKindListDG},
  dgDocumentEdit       in 'Source\Document\dgDocumentEdit.pas' {DocumentEditDG},
  dgDocumentList       in 'Source\Document\dgDocumentList.pas' {DocumentListDG},
  fmDocumentList       in 'Source\Document\fmDocumentList.pas' {DocumentListFM},
  dgFirmEdit           in 'Source\Firm\dgFirmEdit.pas' {FirmEditDG},
  dgFirmList           in 'Source\Firm\dgFirmList.pas' {FirmListDG},
  dgTrademarkEdit      in 'Source\Firm\dgTrademarkEdit.pas' {TrademarkEditDG},
  dgTrademarkList      in 'Source\Firm\dgTrademarkList.pas' {TrademarkListDG},
  dgKindEdit           in 'Source\Kind\dgKindEdit.pas' {KindEditDG},
  dgKindFind           in 'Source\Kind\dgKindFind.pas' {KindFindDG},
  dgKindList           in 'Source\Kind\dgKindList.pas' {KindListDG},
  dgDepartmentEdit     in 'Source\Layout\Department\dgDepartmentEdit.pas' {DepartmentEditDG},
  dgDepartmentFind     in 'Source\Layout\Department\dgDepartmentFind.pas' {DepartmentFindDG},
  dgElementEdit        in 'Source\Layout\Device\Element\dgElementEdit.pas' {CompleteSetEditDG},
  dgElementMoveEdit    in 'Source\Layout\Device\Element\dgElementMoveEdit.pas' {ElementMoveEditDG},
  dgElementMoveList    in 'Source\Layout\Device\Element\dgElementMoveList.pas' {ElementMoveListDG},
  dgDeviceEdit         in 'Source\Layout\Device\dgDeviceEdit.pas' {DeviceEditDG},
  dgDeviceFind         in 'Source\Layout\Device\dgDeviceFind.pas' {DeviceFindDG},
  dgWorkplaceEdit      in 'Source\Layout\Workplace\dgWorkplaceEdit.pas' {WorkplaceEditDG},
  dgWorkplaceFind      in 'Source\Layout\Workplace\dgWorkplaceFind.pas' {WorkplaceFindDG},
  fmLayout             in 'Source\Layout\fmLayout.pas' {LayoutMainFM},
  dgModelEdit          in 'Source\Model\dgModelEdit.pas' {ModelEditDG},
  dgModelFind          in 'Source\Model\dgModelFind.pas' {ModelFindDG},
  dgModelList          in 'Source\Model\dgModelList.pas' {ModelListDG},
  fmModelList          in 'Source\Model\fmModelList.pas' {ModelListFM},
  dgComputerPing       in 'Source\Net\Computer\dgComputerPing.pas' {ComputerPingDG},
  dgUserInstall        in 'Source\Net\User\Install\dgUserInstall.pas' {UserInstallDG},
  dgUserInstallDefault in 'Source\Net\User\Install\dgUserInstallDefault.pas' {UserInstallDefaultDG},
  dgUserDCScan         in 'Source\Net\User\dgUserDCScan.pas' {UserDCScanDG},
  dgUserEdit           in 'Source\Net\User\dgUserEdit.pas' {UserEditDG},
  dgUserIgnoreList     in 'Source\Net\User\dgUserIgnoreList.pas' {UserIgnoreDG},
  dgUserComputerEdit   in 'Source\Net\dgUserComputerEdit.pas' {UseComputerDG},
  fmNetComputer        in 'Source\Net\fmNetComputer.pas' {NetComputerFM},
  fmNetUser            in 'Source\Net\fmNetUser.pas' {NetUserFM},
  fmSearch             in 'Source\Search\fmSearch.pas' {SearchFM},
  fmSplash             in 'Source\Splash\fmSplash.pas' {SplashFM},
  fmMain               in 'Source\fmMain.pas' {MainFM};
{ Total: 42 customer modules, 3 base modules }

{$R *.RES}
begin
  SplashFM:=TSplashFM.Create(Application);
  SplashFM.Show;
  SplashFM.Update;
  Application.Initialize;
  Application.Title := 'ComputerWare';
  Application.CreateForm(TdmComming, dmComming);
  Application.CreateForm(TdmChain, dmChain);
  Application.CreateForm(TMainFM, MainFM);
  Application.CreateForm(TdmLookUp, dmLookUp);
  SplashFM.ExFree;
  Application.Run;
end.
