{=======================================================================================================================

   " ".

    , .

========================================================================================================================

  :

  16.11.2015 [*] ActionUpdate.
  04.03.2015 [-] .
  01.03.2015 [+]  () .
  26.02.2015 [+]  (   ).
  22.03.2015 [+]  () .
  14.02.2015 [*]       ( 8).
  08.06.2013 [*] .
             [*]    (edDate)      .
  07.06.2013 [+]  .
  24.03.2012 [*]    dmComming.
             [*]    CommingADO.
  20.12.2012 [*]   (Hint).
  12.02.2012 [-]  -.
             [*] .
             [!]  .
  09.02.2012 [!]    Delphi XE2.
  30.03.2011 [*]    .
  04.08.2009 [+]     btExit.
  26.07.2007 [*]      .
  10.07.2007 [*]   Vista.
  20.03.2007 [+]   .
  14.02.2007 [+]    .
             [*]   XP.
  07.02.2005 [*]     .
             [*] .
  19.11.2001 [*] tbPlace:    ADO.
             [*] tbSpec:    ADO.
             [-]  .
             [*] tbDoc:    ADO.
  15.11.2001 [-]  TAB.
             [*]    .
  08.11.2001 [*]  Comming.
             [*]    .
             [-]  TAB.
             [*]   MS SQL Server 2000  ODBC   TDataSet.
  01.01.1999 [+]  .  .
  09.10.1997 [!]  .

========================================================================================================================
  Copyright 19972015 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: fmDocumentList.pas,v 1.18 2015/11/16 02:18:13 tsk Exp $
=======================================================================================================================}
unit fmDocumentList;

interface

uses  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls, Mask, DBGridEh, ADODB,
      ToolWin, ComCtrls, DB, DBCtrls, Grids, ExtCtrls, Buttons, ActnList, PropFilerEh, PropStorageEh, DBGridEhGrouping,
      GridsEh, ToolCtrlsEh, DBGridEhToolCtrls, DynVarsEh, System.Actions, DBAxisGridsEh, Vcl.Menus,
      // ComputerWare:
      dgDocumentEdit, dmCommingData,
      // Comming:
      CommingDialog, CommingADO;

type
  TDocumentListFM = class( TForm )
    spPos: TSplitter;
    spDelDocum: TADOStoredProc;
    grSpec: TDBGridEh;
    grDoc: TDBGridEh;
    dsDoc: TDataSource;
    dsSpec: TDataSource;
    taDoc: TADODataSet;
    taSpec: TADODataSet;
    taDocDocDate: TDateTimeField;
    taDocDocName: TStringField;
    taDocClientName: TStringField;
    tbDoc: TToolBar;
    btInsert: TToolButton;
    btEdit: TToolButton;
    btDelete: TToolButton;
    alDoc: TActionList;
    acInsertDoc: TAction;
    acEditDoc: TAction;
    acDeleteDoc: TAction;
    stMain: TPropStorageEh;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    dtDoc: TDateTimePicker;
    ToolButton5: TToolButton;
    acGoDevice: TAction;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    taDocID: TIntegerField;
    taDocSum: TBCDField;
    taSpecID: TIntegerField;
    taSpecPosition: TSmallintField;
    taSpecKind: TStringField;
    taSpecModel: TStringField;
    taSpecNumber: TStringField;
    taSpecPrice: TBCDField;
    taSpecDepartment: TStringField;
    taSpecPlace: TStringField;
    taSpecDevice: TStringField;
    taSpecLast: TDateTimeField;
    taSpecWarranty: TDateTimeField;
    taSpecManufact: TDateTimeField;
    taSpecIDDevice: TIntegerField;
    acDocPrint: TAction;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton10: TToolButton;
    acDocKind: TAction;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    pmChain: TPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    acDocShipper: TAction;
    N3: TMenuItem;
    acDocTrademark: TAction;
    N4: TMenuItem;
    procedure acInsertDocExecute(Sender: TObject);
    procedure acEditDocExecute(Sender: TObject);
    procedure acDeleteDocExecute(Sender: TObject);
    procedure acRefreshDocExecute(Sender: TObject);
    procedure dtDocChange(Sender: TObject);
    procedure acGoDeviceUpdate(Sender: TObject);
    procedure acGoDeviceExecute(Sender: TObject);
    procedure acInsertDocUpdate(Sender: TObject);
    procedure acEditDocUpdate(Sender: TObject);
    procedure acDocPrintExecute(Sender: TObject);
    procedure acDocKindExecute(Sender: TObject);
    procedure acDocTrademarkExecute(Sender: TObject);
    procedure acDocShipperExecute(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private   { Private declarations }
    FGoToDate: Boolean;
  public    { Public declarations }
    procedure RefreshDoc( ID: Integer= CURRENT_RECORD; IDPos: Integer = CURRENT_RECORD );
    procedure RefreshComponent( Component: Integer = CURRENT_RECORD );
  end;

var  DocumentListFM: TDocumentListFM;

implementation

uses fmMain, fmLayout, dgFirmList, dmChainData, dgDocumentKindList, dgTrademarkList;
{$R *.DFM}
//======================================================================================================================
{ TDocumentListFM }
//======================================================================================================================
procedure TDocumentListFM.FormShow(Sender: TObject);
begin
  Width   := MainFM.tsDocument.ClientWidth + 1;
  Height  := MainFM.tsDocument.ClientHeight + 1;
end;
//======================================================================================================================
procedure TDocumentListFM.RefreshDoc( ID, IDPos: Integer );
begin
  Screen.Cursor := crHourGlass;
  if taDoc.Active and ( ID = CURRENT_RECORD) then begin
    ID := taDocID.Value;
    FGoToDate := True;
  end;
  RequeryParameters( taDoc, []);
  taDoc.Locate( 'ID', ID, [] );
  RequeryParameters( taSpec, [ ID ]);
  if IDPos > 0 then taSpec.Locate( 'Position', IDPos, [] );
  Screen.Cursor := crDefault;
end;
//======================================================================================================================
procedure TDocumentListFM.RefreshComponent(Component: Integer);
begin
  Screen.Cursor := crHourGlass;
  if Component = CURRENT_RECORD then Exit;
  dmChain.Component := Component;
  RefreshDoc( dmChain.Document, dmChain.DocumentPosition );
end;
//======================================================================================================================
{  }
//======================================================================================================================
// :
procedure TDocumentListFM.acInsertDocUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := ActionInsert( taDoc )
end;
//======================================================================================================================
procedure TDocumentListFM.acInsertDocExecute(Sender: TObject);
begin
  if DocumentEditDG.Run( INSERT_DATA ) then RefreshDoc( DocumentEditDG.taDataIdDocument.Value );
end;
//======================================================================================================================
// :
procedure TDocumentListFM.acEditDocUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := ActionUpdate( taDoc )
end;
//======================================================================================================================
procedure TDocumentListFM.acEditDocExecute(Sender: TObject);
begin
  if DocumentEditDG.Run( taDocID.Value ) then RefreshDoc( DocumentEditDG.taDataIdDocument.Value );
end;
//======================================================================================================================
// :
procedure TDocumentListFM.acDeleteDocExecute(Sender: TObject);
begin
  if ShowWarning( ': %d'#13'%s  %s'#13' %s'#13' %m?',
      [taDocID.Value, taDocDocName.Value, taDocDocDate.AsString, taDocClientName.Value, taDocSum.Value ] ) then begin
    DeleteRecord( 'Document', taDocID, 'IdDocument' );
    taDoc.Prior;
    RefreshDoc( CURRENT_RECORD );
  end;
end;
//======================================================================================================================
// :
procedure TDocumentListFM.acRefreshDocExecute(Sender: TObject);
begin
  RefreshDoc( CURRENT_RECORD );
end;
//======================================================================================================================
// :
procedure TDocumentListFM.acDocPrintExecute(Sender: TObject);
begin
  MainFM.ViewReport( 'document&rs:Command=Render&DOC=' + taDocID.AsString );
end;
//======================================================================================================================
{  }
//======================================================================================================================
procedure TDocumentListFM.acDocKindExecute(Sender: TObject);
begin
  DocumentKindListDG.Run;
end;
//======================================================================================================================
procedure TDocumentListFM.acDocTrademarkExecute(Sender: TObject);
begin
  TrademarkListDG.Run;
end;
//======================================================================================================================
procedure TDocumentListFM.acDocShipperExecute(Sender: TObject);
begin
  FirmListDG.Run;
end;
//======================================================================================================================
procedure TDocumentListFM.dtDocChange(Sender: TObject);
//  var ID: Integer;
begin
  if FGoToDate then begin
//    ID := dmComming.GetDocumentDate( dtDoc.Date );
//    taDoc.Locate( 'ID', ID, [] );
  end;
  FGoToDate := True;
end;
//======================================================================================================================
{  }
//======================================================================================================================
procedure TDocumentListFM.acGoDeviceUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := ( taSpec.Active ) and ( taSpec.RecordCount > 0 );
end;
//======================================================================================================================
procedure TDocumentListFM.acGoDeviceExecute(Sender: TObject);
begin
  MainFM.pcMain.ActivePage := MainFM.tsLayout;
  LayoutMainFM.FindNode( 'V', taSpecIDDevice.Value );
end;
//======================================================================================================================
end.







