{=======================================================================================================================

   "".

    , , .

========================================================================================================================

  :

  08.03.2015 [*]  .
  27.02.2015 [+] , .
  26.02.2015 [+] , .
             [*]   ClientList.
  25.02.2015 [*]  DBNavigator  .
             [-] TPropStorageEh.
  15.02.2015 [+]  .
             [*]    ClntNameShort.
  04.04.2012 [*]  .
             [+]  .
  26.02.2012 [*]    .
  09.02.2012 [!]    Delphi XE2.
  30.03.2011 [*]   96 PixelsPerInch.
  14.11.2006 [*]   XP.
  19.11.2001 [*]  .
  14.11.2001 [*]   TBASEListDG.
  09.11.2001 [*]    .
             [*]  .
             [*]  Comming.
             [-]  TAB.
  01.01.1999 [+]  .  .
  09.10.1997 [!]  .

========================================================================================================================
  Copyright 19972015 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: dgFirmList.pas,v 1.1 2015/03/08 05:02:36 tsk Exp $
=======================================================================================================================}
unit dgFirmList;

interface

uses  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, Dialogs, DB, StdCtrls, Buttons, Grids,
      DBGridEh, ExtCtrls, DBCtrls, ADODB, DBGridEhGrouping, GridsEh, ToolCtrlsEh, DBGridEhToolCtrls, DynVarsEh,
      DBAxisGridsEh,
      // ComputerWare & Comming:
      dgBaseList, CommingADO, CommingDialog;

type
  TFirmListDG = class(TBASEListDG)
    taFirm: TADODataSet;
    taFirmID: TIntegerField;
    taFirmTradeName: TStringField;
    taFirmClientName: TStringField;
    taFirmCountDoc: TIntegerField;
    taFirmCountModel: TIntegerField;
    procedure btBackClick(Sender: TObject);
    procedure btInsertClick(Sender: TObject);
    procedure btEditClick(Sender: TObject);
    procedure btDeleteClick(Sender: TObject);
  private   { Private declarations }
    procedure RefreshData( ID: Integer = CURRENT_RECORD );
  public    { Public declarations }
    function Run( ID: Integer = -1; InField: TField = nil ): Integer ;
  end;

var  FirmListDG: TFirmListDG;

implementation

{$R *.dfm}

uses dgTrademarkList, dgFirmEdit;
//======================================================================================================================
{ TFirmListDG }
//======================================================================================================================
function TFirmListDG.Run( ID: Integer; InField: TField ): Integer;
  const Def: Integer = 1;
begin
  if FirmListDG = nil then Application.CreateForm( TFirmListDG, FirmListDG );
  with FirmListDG do begin
    Field := InField;
    RefreshData( ID );
    Result := ShowModal;
  end;
end;
//======================================================================================================================
procedure TFirmListDG.RefreshData( ID: Integer );
begin
  if ((ID = CURRENT_RECORD) and ( taFirm.Active )) then ID := taFirmID.Value;
  RequeryParameters( taFirm, [] );
  taFirm.Locate( 'ID', ID, []);
end;
//======================================================================================================================
procedure TFirmListDG.btInsertClick(Sender: TObject);
begin
//  inherited;
  if FirmEditDG.Run( INSERT_DATA ) then RefreshData( FirmEditDG.taDataIdClient.Value );
end;
//======================================================================================================================
procedure TFirmListDG.btEditClick(Sender: TObject);
begin
//  inherited;
  if FirmEditDG.Run( taFirmID.Value ) then RefreshData( FirmEditDG.taDataIdClient.Value );
end;
//======================================================================================================================
procedure TFirmListDG.btDeleteClick(Sender: TObject);
begin
//  inherited;
  if ShowWarning( '   "' + taFirmClientName.AsString + '"?' ) then begin
    DeleteRecord( 'Client', taFirmID, 'IdClient' );
    taFirm.Prior;
    RefreshData;
  end;
end;
//======================================================================================================================
procedure TFirmListDG.btBackClick(Sender: TObject);
begin
  inherited;
  SetBackValue( taFirmID.Value );
end;
//======================================================================================================================
end.
