{=======================================================================================================================

   " ".

    , , .

========================================================================================================================

  :

  08.03.2015 [+]   .
  04.03.2015 [*]  dsEdit   .
  28.02.2015 [+]  taSet   taData.
  25.02.2015 [*]   -       .
             [*]  dmLookUp  .
  22.02.2015 [+]  dmLookUp.
             [-] TPropStorageEh.
  14.07.2012 [+]   .
  09.03.2012 [*]  .
  28.02.2012 [*]  .
             [+]  .
             [*]    .
  24.02.2012 [*] .
  19.02.2012 [*]    Unicode.
  09.02.2012 [!]    Delphi XE2.
  08.07.2011 [*]     TAB.
  11.07.2007 [-]  TAB.
  02.07.2007 [-]  uses    RXLib.
  13.02.2007 [*]    .
             [*]    .
  05.02.2007 [*]   .
  26.12.2006 [*]      XP.
  25.12.2006 [*]    tbSetCmplNumber  20  50.
  18.12.2006 [*]   XP.
  15.11.2001 [*]     ADO.
             [*]  .
  12.11.2001 [*]        .
             [*]      .
  09.11.2001 [*]    .
             [*]     RecordExchangeMoving.
             [*]  .
  08.11.2001 [+]  Comming.
             [*]    .
             [-]  TAB.
  06.11.2001 [*]   MS SQL Server 2000  ODBC   TDataSet.
             [*]   Delphi 6.
  01.01.1999 [+]  .  .
  09.10.1997 [!]  .

========================================================================================================================
  Copyright 19972015 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: dgElementEdit.pas,v 1.15 2015/06/05 05:04:44 tsk Exp $
=======================================================================================================================}
unit dgElementEdit;

interface

uses  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, Buttons, StdCtrls,
      Db, Mask, DBCtrls, ADODB, Variants, DBCtrlsEh, DBGridEh, DBLookupEh,
      // Comming & ComputerWare:
      CommingOther, CommingADO, CommingDateTime, dgBaseEdit, dgModelList, dgKindList, dmCommingData;

type
  TCompleteSetEditDG = class(TBASEEditDG)
    lcKind: TDBLookupComboboxEh;
    Label3: TLabel;
    sbKind: TSpeedButton;
    sbModel: TSpeedButton;
    lcModel: TDBLookupComboboxEh;
    Label4: TLabel;
    edNumberDIT: TDBEdit;
    Label2: TLabel;
    edDataSet: TDBDateTimeEditEh;
    grDoc: TGroupBox;
    sbDoc: TSpeedButton;
    lcDoc: TDBLookupComboboxEh;
    dbeSpecPos: TDBEdit;
    laPos: TLabel;
    laDocPrice: TLabel;
    edModelNote: TDBEdit;
    gbModel: TGroupBox;
    gbManufact: TGroupBox;
    Label7: TLabel;
    DBEdit5: TDBEdit;
    Label8: TLabel;
    edDateManText: TEdit;
    edDateMan: TDBDateTimeEditEh;
    gbSeller: TGroupBox;
    Label6: TLabel;
    DBEdit6: TDBEdit;
    DBEdit7: TDBEdit;
    Label9: TLabel;
    Label10: TLabel;
    dbeSpecPrice: TDBEdit;
    spDocument: TADOStoredProc;
    btClear: TSpeedButton;
    taDataIdComponent: TAutoIncField;
    taDataCmplIdDevice: TIntegerField;
    taDataCmplDateSet: TDateTimeField;
    taDataCmplIdModel: TIntegerField;
    taDataCmplNumber: TStringField;
    taDataNumberManufact: TStringField;
    taDataDateManufact: TDateTimeField;
    taDataNumberSeller: TStringField;
    taDataDateSeller: TDateTimeField;
    taDataWarranty: TSmallintField;
    taDataDocumentId: TIntegerField;
    taDataDocumentPosition: TSmallintField;
    taDataPrice: TBCDField;
    taDataModelKind: TSmallintField;
    sbFindModel: TSpeedButton;
    procedure lcKindChange(Sender: TObject);
    procedure sbDocClick(Sender: TObject);
    procedure sbKindClick(Sender: TObject);
    procedure sbModelClick(Sender: TObject);
    procedure edDateManChange(Sender: TObject);
    procedure btSaveClick(Sender: TObject);
    procedure btFindClick(Sender: TObject);
    procedure btClearClick(Sender: TObject);
  private   { Private declarations }
  public    { Public declarations }
    function Run( CompSet, Device: Integer; KindType: String ): Boolean;
  end;

var  CompleteSetEditDG: TCompleteSetEditDG;

implementation

uses dgDocumentList, dgModelFind, dmLookUpData, dmChainData;

{$R *.DFM}
//======================================================================================================================
function TCompleteSetEditDG.Run( CompSet, Device: Integer; KindType: String ): Boolean;
begin
  Screen.Cursor := crHourGlass;
  try
    if CompleteSetEditDG = nil then Application.CreateForm( TCompleteSetEditDG, CompleteSetEditDG );
    with CompleteSetEditDG do begin
      RequeryParameters( taData, [ CompSet ]);
      if taData.RecordCount = 0 then begin
        taData.Insert;
        taDataCmplIdDevice.Value  := Device;
        taDataCmplDateSet.Value   := Now;
        edModelNote.Clear;
      end;
//      ChainDM.Model := taDataCmplIdModel.Value;
//      if not (ChainDM.KindType = EmptyStr) then KindType := ChainDM.KindType;
      dmLookUp.SetKindType( KindType );
//      SetField( dmLookUp.taMemoryKind, ChainDM.Kind );
//      lcKindChange( Self );
      RequeryParameters( dmLookUp.taDocument, []);
      Result := ( ShowModal = mrOk );
    end;
  finally
    Screen.Cursor := crDefault;
  end;
end;
//======================================================================================================================
procedure TCompleteSetEditDG.lcKindChange( Sender: TObject );
begin
//  if ( dmLookUp.taMemory.State = dsEdit ) then dmLookUp.taMemory.Post;
//  dmLookUp.SetKind( dmLookUp.taMemoryKind.Value );
  dmLookUp.SetKind( dmLookUp.taKindID.Value );
  if ( lcModel.Text = EmptyStr ) then edModelNote.Clear;
//  SetField( taDataCmplIdModel, dmLookUp.taModelID.Value );
//  lcModel.Text := dmLookUp.taModelName.AsString;
end;
//======================================================================================================================
procedure TCompleteSetEditDG.sbKindClick(Sender: TObject);
begin
//  KindListDG.Run( dmLookUp.taKindID.Value, dmLookUp.taMemoryKind, dmLookUp.taKindKindType.AsString );
  KindListDG.Run( dmLookUp.taKindID.Value, taDataModelKind, dmLookUp.taKindKindType.AsString );
end;
//======================================================================================================================
procedure TCompleteSetEditDG.sbModelClick(Sender: TObject);
begin
  lcKind.OnChange := nil;
  if ModelListDG.Run( taDataCmplIdModel.Value, taDataCmplIdModel, lcKind.KeyValue ) then begin
    dmLookUp.SetKind( ModelListDG.taModelModlKind.Value );
    taDataModelKind.Value := ModelListDG.taModelModlKind.Value;
  end;
  lcKind.OnChange := lcKindChange;
end;
//======================================================================================================================
procedure TCompleteSetEditDG.btFindClick(Sender: TObject);
begin
  if ModelFindDG.Run( taDataCmplIdModel ) then begin
    Visual := False;
    dmLookUp.SetKindType( ModelFindDG.taFindKindType.AsString );
    dmLookUp.SetKind( ModelFindDG.taFindKind.Value );
    taDataModelKind.Value := ModelFindDG.taFindKind.Value;
    Visual := True;
  end;
end;
//======================================================================================================================
procedure TCompleteSetEditDG.edDateManChange(Sender: TObject);
begin
  edDateManText.Text := cMonthYear( edDateMan.Value );
end;
//======================================================================================================================
procedure TCompleteSetEditDG.sbDocClick(Sender: TObject);
begin
  DocumentListDG.Run( taDataDocumentId );
  RequeryParameters( dmLookUp.taDocument, []);
end;
//======================================================================================================================
procedure TCompleteSetEditDG.btClearClick(Sender: TObject);
begin
//  inherited;
  SetStateEdit( taData );
  taDataDocumentId.Clear;
  taDataDocumentPosition.Clear;
end;
//======================================================================================================================
procedure TCompleteSetEditDG.btSaveClick(Sender: TObject);
begin
  if Empty( taDataNumberManufact.Value ) then taDataNumberManufact.Clear;
  if Empty( taDataNumberSeller.Value )   then taDataNumberSeller.Clear;
  if Empty( taDataCmplNumber.Value )     then taDataCmplNumber.Clear;
  inherited;
  spDocument.Parameters[1].Value := taDataIdComponent.Value;
  spDocument.ExecProc;
end;
//======================================================================================================================
end.

