{=======================================================================================================================

   "".

     , , .

========================================================================================================================

  :

  08.03.2015 [*]  .
  27.02.2015 [+]   .
  26.02.2015 [+] , , , .
             [*] .
             [*] .
  25.02.2015 [*]  DBNavigator  .
             [-] TPropStorageEh.
  16.02.2015 [+]  .  .
  09.10.1997 [!]  .

========================================================================================================================
  Copyright 19972015 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: dgTrademarkList.pas,v 1.1 2015/03/08 05:02:36 tsk Exp $
=======================================================================================================================}
unit dgTrademarkList;

interface

uses  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, Dialogs, DB, StdCtrls, Buttons, Grids,
      DBGridEh, ExtCtrls, DBCtrls, ADODB, PropFilerEh, PropStorageEh, DBGridEhGrouping, GridsEh, ToolCtrlsEh,
      DBGridEhToolCtrls, DynVarsEh, DBAxisGridsEh,
      // Comming & ComputerWare:
      dgBaseList, CommingADO, CommingDialog;

type
  TTrademarkListDG = class(TBASEListDG)
    taTrade: TADODataSet;
    taTradeID: TSmallintField;
    taTradeName: TStringField;
    taTradeRanking: TSmallintField;
    procedure btBackClick(Sender: TObject);
    procedure btInsertClick(Sender: TObject);
    procedure btEditClick(Sender: TObject);
    procedure btDeleteClick(Sender: TObject);
  private   { Private declarations }
    procedure RefreshData( ID: Integer = CURRENT_RECORD );
  public    { Public declarations }
    function Run( ID: Integer = -1; InField: TField = nil ): Integer ;
  end;

var  TrademarkListDG: TTrademarkListDG;

implementation

{$R *.dfm}

uses dgTrademarkEdit;
//======================================================================================================================
{ TTrademarkListDG }
//======================================================================================================================
function TTrademarkListDG.Run( ID: Integer; InField: TField ): Integer;
  const Def: Integer = 1;
begin
  if TrademarkListDG = nil then Application.CreateForm( TTrademarkListDG, TrademarkListDG);
  with TrademarkListDG do begin
    Field := InField;
    RefreshData( ID );
    Result := ShowModal;
  end;
end;
//======================================================================================================================
procedure TTrademarkListDG.RefreshData(ID: Integer);
begin
  if (ID = CURRENT_RECORD) then ID := taTradeID.Value;
  RequeryParameters( taTrade, [] );
  taTrade.Locate( 'ID', ID, []);
end;
//======================================================================================================================
procedure TTrademarkListDG.btInsertClick(Sender: TObject);
begin
//  inherited;
  if TrademarkEditDG.CheckRun( INSERT_DATA ) then RefreshData( TrademarkEditDG.taDataID.Value );
end;
//======================================================================================================================
procedure TTrademarkListDG.btEditClick(Sender: TObject);
begin
//  inherited;
  if TrademarkEditDG.CheckRun( taTradeID.Value ) then RefreshData( TrademarkEditDG.taDataID.Value );
end;
//======================================================================================================================
procedure TTrademarkListDG.btDeleteClick(Sender: TObject);
begin
//  inherited;
  if ShowWarning( '   "' + taTradeName.AsString + '"?' ) then begin
    DeleteRecord( 'Trademark', taTradeID );
    taTrade.Prior;
    RefreshData;
  end;
end;
//======================================================================================================================
procedure TTrademarkListDG.btBackClick(Sender: TObject);
begin
  inherited;
  SetBackValue( taTradeID.Value );
end;
//======================================================================================================================
end.
