{=======================================================================================================================

   "".

    , , .

========================================================================================================================

  :

  26.02.2015 [*]     .
  22.02.2015 [+]    .
             [-] TPropStorageEh.
  21.02.2015 [!]       ( 8).
  28.02.2012 [-]     .
  27.02.2012 [+]  .
  15.02.2012 [!]  .
  10.02.2012 [*] .
             [+] .
  09.02.2012 [!]    Delphi XE2.
  12.02.2007 [*]     DBLookupCombobox.
  19.12.2006 [*]   .
             [*]    .
  15.12.2006 [*]   XP.
  21.11.2001 [*] tbDepart:    ADO.
             [*]  .
  16.11.2001 [*]    .
             [*]     .
             [+]   .
  12.11.2001 [+]      .
             [*]     RecordExchangeMoving.
             [*]  .
             [*]    .
             [-]  TAB.
             [*]   MS SQL Server 2000  ODBC   TDataSet.
             [*]   Delphi 6.
  01.01.1999 [+]  .  .
  09.10.1997 [!]  .

========================================================================================================================
  Copyright 19972015 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: dgDepartmentEdit.pas,v 1.4 2015/03/08 05:02:37 tsk Exp $
=======================================================================================================================}
unit dgDepartmentEdit;

interface

uses  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, DBCtrls, StdCtrls,
      Mask, Buttons, DBGrids, ExtCtrls, Db, ADODB, Variants, DBGridEh, DBCtrlsEh, DBLookupEh,
      // Comming & ComputerWare:
      dgBaseEdit, CommingADO, dmCommingData, dmLookUpData;

type
  TDepartmentEditDG = class(TBASEEditDG)
    Label1: TLabel;
    edName: TDBEdit;
    Label2: TLabel;
    taDataIdDepartment: TAutoIncField;
    taDataDprtIdHigher: TIntegerField;
    taDataDprtName: TStringField;
    cbHight: TDBLookupComboboxEh;
    Label3: TLabel;
    taDataSynonym: TStringField;
    edSynonym: TDBEdit;
    btFind: TBitBtn;
    procedure btFindClick(Sender: TObject);
    procedure taDataBeforePost(DataSet: TDataSet);
  private   { Private declarations }
  public    { Public declarations }
    function  Run( Dprt: Integer = -1; Higher: Integer = 0 ): Boolean;
  end;

var DepartmentEditDG: TDepartmentEditDG;

implementation

uses dgDepartmentFind;

{$R *.DFM}
//======================================================================================================================
{ TDepartmentEditDG }
//======================================================================================================================
function TDepartmentEditDG.Run( Dprt, Higher: Integer ): Boolean;
begin
  if DepartmentEditDG = nil then Application.CreateForm( TDepartmentEditDG, DepartmentEditDG );
  with DepartmentEditDG do begin
    RequeryParameters( dmLookUp.taDepart, []);
    RequeryParameters( taData, [ Dprt ]);
    if taData.RecordCount = 0 then begin
       taData.Insert;
       taDataDprtIdHigher.Value := Higher;
    end;
    Result := ( ShowModal = mrOk );
  end;
end;
//======================================================================================================================
procedure TDepartmentEditDG.btFindClick(Sender: TObject);
begin
  DepartmentFindDG.Run( taDataDprtIdHigher );
end;
//======================================================================================================================
procedure TDepartmentEditDG.taDataBeforePost( DataSet: TDataSet );
begin
//  inherited;
  if (taDataDprtIdHigher.Value = taDataIdDepartment.Value) then begin
    ShowMessage( '    .' );
    Abort;
  end;
end;
//======================================================================================================================
end.

