{=======================================================================================================================

   " ".

     , , .

========================================================================================================================

  :

  28.02.2015 [+]  taSet   taData.
  25.02.2015 [-] TPropStorageEh.
  14.07.2012 [*]     (   ).
  11.03.2012 [-]   .
  10.03.2012 [*]  .
  01.03.2012 [+]      .
  28.02.2012 [*]    .
             [*]    .
  24.02.2012 [*] .
  22.02.2012 [*]   .
  09.02.2012 [!]    Delphi XE2.
  12.02.2007 [*]     DBLookupCombobox.
  02.07.2007 [-]  uses    RXLib.
  18.12.2006 [*]   XP.
  19.11.2001 [*]   .
             [*]     ADO.
  12.11.2001 [*]        .
  08.11.2001 [+]  Comming.
             [*]    .
             [-]  TAB.
             [*]   MS SQL Server 2000  ODBC   TDataSet.
             [*]   Delphi 6.
  01.01.1999 [+]  .  .
  09.10.1997 [!]  .

========================================================================================================================
  Copyright 19972015 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: dgElementMoveEdit.pas,v 1.7 2015/03/08 05:02:38 tsk Exp $
=======================================================================================================================}
unit dgElementMoveEdit;

interface

uses  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, ExtCtrls, Db, DBCtrls, StdCtrls, Mask,
      ADODB, DBCtrlsEh, DBLookupEh, Buttons, DBGridEh,
      // Comming:
      CommingADO,
      //ComputerWare:
      dgBaseEdit, dmLookUpData, dmCommingData;

type
  TElementMoveEditDG = class( TBASEEditDG )
    Label3: TLabel;
    lcDevice: TDBLookupComboboxEh;
    btFind: TBitBtn;
    spDocument: TADOStoredProc;
    taDataIdComponent: TAutoIncField;
    taDataCmplIdDevice: TIntegerField;
    procedure btFindClick(Sender: TObject);
    procedure btSaveClick(Sender: TObject);
  private   { Private declarations }
  public    { Public declarations }
    function    Run( CompSet: Integer ): Boolean;
  end;

  var ElementMoveEditDG: TElementMoveEditDG;

implementation

{$R *.DFM}

uses dgDeviceFind;
//======================================================================================================================
{ TElementMoveEditDG }
//======================================================================================================================
function TElementMoveEditDG.Run( CompSet: Integer ): Boolean;
begin
  if ElementMoveEditDG = nil then Application.CreateForm( TElementMoveEditDG, ElementMoveEditDG);
  with ElementMoveEditDG do begin
    RequeryParameters( dmLookUp.taDevice, [ CompSet, 0 ]);
    RequeryParameters( taData, [ CompSet ]);
    Result := ( ShowModal = mrOk );
  end;
end;
//======================================================================================================================
procedure TElementMoveEditDG.btFindClick(Sender: TObject);
begin
  DeviceFindDG.Run( taDataCmplIdDevice )
end;
//======================================================================================================================
procedure TElementMoveEditDG.btSaveClick(Sender: TObject);
begin
  spDocument.Parameters[1].Value := taDataIdComponent.Value;
  spDocument.ExecProc;
  inherited;
end;
//======================================================================================================================
end.
