{=======================================================================================================================

   " ".

     , , .

========================================================================================================================

  :

  25.02.2015 [*]  DBNavigator  .
  10.03.2012 [*]  .
  28.02.2012 [*]    .
  22.02.2012 [*] .
  09.02.2012 [!]    Delphi XE2.
  31.03.2011 [*]   Windows 7.
  16.11.2006 [*]   XP.
  20.11.2001 [-]  .
             [+]  Comming.
             [*]      .
             [*]      .
  19.11.2001 [+]  .  .
  09.10.1997 [!]  .

========================================================================================================================
  Copyright 19972015 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: dgElementMoveList.pas,v 1.4 2015/03/08 05:02:38 tsk Exp $
=======================================================================================================================}
unit dgElementMoveList;

interface

uses  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, Dialogs, DB, StdCtrls, Buttons, Grids,
      DBGridEh, ExtCtrls, DBCtrls, ADODB, Mask, DBGridEhGrouping, GridsEh, ToolCtrlsEh, DBGridEhToolCtrls, DynVarsEh,
      DBAxisGridsEh,
      // CW
      dgBaseList, dgElementMoveEdit,
      // Comming
      CommingDialog, CommingADO;

type
  TElementMoveListDG = class( TBASEListDG )
    taMove: TADODataSet;
    taMoveID: TAutoIncField;
    taMoveMoving: TDateTimeField;
    taMovePlace: TStringField;
    procedure btInsertClick(Sender: TObject);
  private   { Private declarations }
    FSet: Integer;
  public    { Public declarations }
    function   Run( CompSet: Integer ): Boolean;
  end;

  var ElementMoveListDG: TElementMoveListDG;

implementation

{$R *.dfm}
//======================================================================================================================
{ TElementMoveListDG }
//======================================================================================================================
function TElementMoveListDG.Run( CompSet: Integer ): Boolean;
  var r: Integer;
begin
  if ElementMoveListDG = nil then Application.CreateForm( TElementMoveListDG, ElementMoveListDG);
  with ElementMoveListDG do begin
    FSet := CompSet;
    RequeryParameters( taMove, [ CompSet ]);
    r := taMove.RecordCount;
    ShowModal;
    Result := ( taMove.RecordCount <> r );
  end;
end;
//======================================================================================================================
procedure TElementMoveListDG.btInsertClick(Sender: TObject);
begin
//  inherited;
  if ElementMoveEditDG.Run( FSet ) then taMove.Refresh;
end;
//======================================================================================================================
end.
