{=======================================================================================================================

   " ".

     , .

========================================================================================================================

  :

  04.03.2015 [+] RefreshWorkPlace:   .
  01.03.2015 [*] .
  16.02.2015 [-] .
  15.02.2015 [*]       ( 8).
             [-]   .
  23.07.2014 [+]     .
             [*]       .
  28.06.2014 [+]    (on-off line).
  27.05.2014 [+]   .
  16.04.2014 [+]   .
  04.04.2012 [+]   .
  18.03.2012 [*]  .
  17.03.2012 [*]    .
  15.03.2012 [+]    .
             [*]    .
             [+]  ""  "".
             [*]  .
  20.02.2012 [*] .
  09.02.2012 [!]    Delphi XE2.
  04.05.2011 [*]    .
  30.03.2011 [*]    .
  07.08.2009 [+] : .
  04.08.2009 [+]     btExit.
  26.07.2009 [+]  .  .
  09.10.1997 [!]  .

========================================================================================================================
  Copyright 19972015 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: fmNetComputer.pas,v 1.5 2015/03/08 05:02:40 tsk Exp $
=======================================================================================================================}
unit fmNetComputer;

interface

uses  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls, Mask, DBGridEh, ADODB,
      ToolWin, ComCtrls, DB, DBCtrls, Grids, ExtCtrls, Buttons, ActnList, DBGridEhGrouping, GridsEh,
      PropFilerEh, PropStorageEh, ToolCtrlsEh, DBGridEhToolCtrls, System.Actions, DBAxisGridsEh, DynVarsEh,
      // ComputerWare:
      dmCommingData, dgUserDCScan, dgUserEdit, dgUserInstall,
      // Comming:
      CommingADO, CommingDialog;

type
  TNetComputerFM = class(TForm)
    spPos: TSplitter;
    grUser: TDBGridEh;
    grDevice: TDBGridEh;
    dsNode: TDataSource;
    taNode: TADODataSet;
    tbMain: TToolBar;
    alNet: TActionList;
    acRefresh: TAction;
    stMain: TPropStorageEh;
    ToolButton5: TToolButton;
    acGoDevice: TAction;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    taNodeID: TIntegerField;
    taNodeWorkplace: TStringField;
    taNodePhone: TStringField;
    taUser: TADODataSet;
    dsUser: TDataSource;
    taUserID: TIntegerField;
    taUserLogin: TStringField;
    taUserName: TStringField;
    taUserPass: TStringField;
    spUser: TADOStoredProc;
    taDCUser: TADODataSet;
    dsDCUser: TDataSource;
    taDCUserID: TIntegerField;
    taDCUserLogin: TStringField;
    taDCUserDomain: TStringField;
    taDCUserName: TStringField;
    taDCUserWorkplace: TStringField;
    taDCUserPhone: TStringField;
    taDCUserPass: TStringField;
    taDCUserAddName: TStringField;
    taDCUserEMail: TStringField;
    taDCUserMailPass: TStringField;
    ToolButton13: TToolButton;
    ToolButton12: TToolButton;
    ToolButton14: TToolButton;
    taNodeDomain: TStringField;
    ToolButton15: TToolButton;
    acPing: TAction;
    taDCUserWorkplaceID: TIntegerField;
    taDCUserEMailGroup: TStringField;
    acReport: TAction;
    taNodeIDWorkplae: TIntegerField;
    procedure acGoDeviceUpdate(Sender: TObject);
    procedure acGoDeviceExecute(Sender: TObject);
    procedure acRefreshExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure acPingUpdate(Sender: TObject);
    procedure acPingExecute(Sender: TObject);
    procedure acRefreshUpdate(Sender: TObject);
    procedure acReportExecute(Sender: TObject);
  private   { Private declarations }
  public    { Public declarations }
    procedure   RefreshNet( ID: Integer = -1 );
    procedure   RefreshWorkPlace( ID: Integer );
  end;

  procedure NetRun( ID: Integer = -1 );

var  NetComputerFM: TNetComputerFM;

implementation

uses fmMain, fmLayout, dgUserComputerEdit, dgComputerPing;
{$R *.DFM}
//======================================================================================================================
{ TNetComputerFM }
//======================================================================================================================
procedure NetRun( ID: Integer );
begin
  Screen.Cursor := crHourGlass;
  try
    if NetComputerFM = nil then Application.CreateForm( TNetComputerFM, NetComputerFM );
    with NetComputerFM do begin
      if WindowState = wsMinimized then WindowState := wsNormal;
      Show;
      RefreshNet( ID );
    end;
  finally
    Screen.Cursor := crDefault;
  end;
end;
//======================================================================================================================
procedure TNetComputerFM.FormCreate(Sender: TObject);
begin
  inherited;
  taUser.Open;
end;
//======================================================================================================================
procedure TNetComputerFM.RefreshNet( ID: Integer );
begin
  Screen.Cursor := crHourGlass;
  RequeryParameters( taNode, []);
  taNode.Locate('ID', ID, [] );
  Screen.Cursor := crDefault;
end;
//======================================================================================================================
procedure TNetComputerFM.RefreshWorkPlace(ID: Integer);
begin
  taNode.Locate( 'IDWorkplae', ID, []);
end;
//======================================================================================================================
// 
//======================================================================================================================
procedure TNetComputerFM.acPingUpdate(Sender: TObject);
begin
//  TAction(Sender).Enabled := (pcNet.ActivePage = tsComputer );
end;
//======================================================================================================================
procedure TNetComputerFM.acPingExecute(Sender: TObject);
begin
  ComputerPingDG.Run;
end;
//======================================================================================================================
procedure TNetComputerFM.acRefreshUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := ( taNode.Active );
end;
//======================================================================================================================
procedure TNetComputerFM.acRefreshExecute(Sender: TObject);
begin
  RefreshNet( taNodeID.Value );
end;
//======================================================================================================================
procedure TNetComputerFM.acReportExecute(Sender: TObject);
begin
  MainFM.ViewReport( 'computer.list' );  //  .
end;
//======================================================================================================================
procedure TNetComputerFM.acGoDeviceUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := ( taNode.Active ) and ( taNode.RecordCount > 0 );
end;
//======================================================================================================================
procedure TNetComputerFM.acGoDeviceExecute(Sender: TObject);
begin
  MainFM.pcMain.ActivePage := MainFM.tsLayout;
  LayoutMainFM.FindNode( 'V', taNodeID.Value );
end;
//======================================================================================================================
end.







